"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RawEditor = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

// CodeMirror plugins


var _templateObject = _taggedTemplateLiteral(["\n  &.react-codemirror2 {\n    height: 100%;\n  }\n\n  .CodeMirror {\n    height: 100%;\n    width: 100%;\n\n    font-feature-settings: \"calt\" 1;\n    font-variant-ligatures: contextual;\n    font-family: \"Fira Code\", Monaco, monospace;\n    font-weight: 400;\n\n    background: ", ";\n    color: ", ";\n\n    direction: ltr;\n  }\n\n  /* Vertical padding around content */\n  .CodeMirror-lines {\n    padding: 0.5rem 0;\n  }\n\n  /* Horizontal padding of content */\n  .CodeMirror pre {\n    padding: 0 0.5rem;\n  }\n\n  /* The little square between H and V scrollbars? */\n  .CodeMirror-scrollbar-filler,\n  .CodeMirror-gutter-filler {\n    background-color: red;\n  }\n\n  /* Gutters */\n  .CodeMirror-gutters {\n    border-right-width: 1px;\n    border-right-style: solid;\n    border-right-color: ", ";\n\n    background-color: ", ";\n    white-space: nowrap;\n  }\n\n  .CodeMirror-linenumbers {\n  }\n\n  .CodeMirror-linenumber {\n    padding: 0 0.25rem 0 0.25rem;\n    margin: 0;\n\n    min-width: 1.5rem;\n    text-align: right;\n\n    color: ", ";\n    white-space: nowrap;\n  }\n\n  .CodeMirror-guttermarker {\n    color: ", ";\n  }\n\n  .CodeMirror-guttermarker-subtle {\n    color: ", ";\n  }\n\n  /* Cursor */\n  .CodeMirror-cursor {\n    border-left-width: 2px;\n    border-left-style: solid;\n    border-left-color: ", ";\n\n    width: 0;\n  }\n\n  /* Shown when moving in bi-directional text */\n  .CodeMirror div.CodeMirror-secondarycursor {\n    border-left-width: 2px;\n    border-left-style: solid;\n    border-left-color: ", ";\n  }\n\n  /* Can style cursor different in overwrite (non-insert) mode */\n  .CodeMirror-overwrite .CodeMirror-cursor {\n  }\n\n  .CodeMirror-ruler {\n    position: absolute;\n    top: 0;\n    bottom: 0;\n\n    border-left-width: 2px;\n    border-left-style: solid;\n    border-left-color: ", ";\n  }\n\n  .CodeMirror-selected {\n    background-color: ", ";\n  }\n\n  .CodeMirror-focused .CodeMirror-selected {\n    background-color: ", ";\n    color: ", ";\n  }\n\n  .CodeMirror-line::selection,\n  .CodeMirror-line > span::selection,\n  .CodeMirror-line > span > span::selection {\n    background-color: ", ";\n    color: ", ";\n  }\n\n  .CodeMirror-crosshair {\n    cursor: crosshair;\n  }\n\n  .CodeMirror-activeline-background {\n    background-color: ", ";\n  }\n\n  .cm-searching {\n    background-color: ", ";\n  }\n\n  .cm-header,\n  .cm-strong {\n    font-weight: bold;\n  }\n\n  .cm-em {\n    font-style: italic;\n  }\n\n  .cm-link {\n    text-decoration: underline;\n  }\n\n  .cm-strikethrough {\n    text-decoration: line-through;\n  }\n\n  .cm-s-default {\n    .cm-keyword {\n      color: ", ";\n    }\n\n    .cm-meta,\n    .cm-bracket,\n    .cm-operator,\n    .cm-qualifier,\n    .cm-punctuation {\n      color: ", ";\n    }\n\n    .cm-comment {\n      color: ", ";\n    }\n\n    .cm-variable,\n    .cm-variable-2,\n    .cm-variable-3 {\n      color: ", ";\n    }\n\n    .cm-property {\n      color: ", ";\n    }\n\n    .cm-tag {\n      color: ", ";\n    }\n\n    .cm-number,\n    .cm-string,\n    .cm-string-2 {\n      color: ", ";\n    }\n\n    .cm-attribute {\n      color: ", ";\n    }\n\n    .cm-atom {\n      color: ", ";\n    }\n\n    .cm-def {\n      color: ", ";\n    }\n\n    .cm-type {\n      color: ", ";\n    }\n\n    .cm-builtin {\n      color: ", ";\n    }\n\n    .cm-hr {\n      color: ", ";\n    }\n\n    .cm-link {\n      color: ", ";\n    }\n\n    .cm-error {\n      color: #d44;\n    }\n\n    .cm-quote {\n      color: ", ";\n    }\n\n    .cm-header {\n      color: blue;\n    }\n  }\n\n  .cm-negative {\n    color: #d44;\n  }\n  .cm-positive {\n    color: #292;\n  }\n\n  .cm-invalidchar {\n    color: #d44;\n  }\n\n  /* Default styles for common addons */\n\n  div.CodeMirror span.CodeMirror-matchingbracket {\n    color: #0b0;\n  }\n\n  div.CodeMirror span.CodeMirror-nonmatchingbracket {\n    color: #a22;\n  }\n\n  .CodeMirror-matchingtag {\n    background: rgba(255, 150, 0, 0.3);\n  }\n\n  .CodeMirror-composing {\n    border-bottom-width: 2px;\n    border-bottom-style: solid;\n  }\n\n  .cm-tab {\n    display: inline-block;\n    text-decoration: inherit;\n  }\n\n  .CodeMirror-rulers {\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: -50px;\n    bottom: -20px;\n\n    overflow-x: hidden;\n    overflow-y: hidden;\n  }\n\n  /**\n   * The rest of this file contains styles related to the mechanics of the\n   * editor. You probably shouldn't touch them.\n   */\n\n  .CodeMirror {\n    position: relative;\n    overflow: hidden;\n  }\n\n  .CodeMirror-scroll {\n    position: relative;\n\n    /* 30px is the magic margin used to hide the element's real scrollbars */\n    /* See overflow: hidden in .CodeMirror */\n    margin-bottom: -30px;\n    margin-right: -30px;\n    padding-bottom: 30px;\n\n    height: 100%;\n    outline: none;\n\n    /* Things will break if this is overridden */\n    overflow: scroll !important;\n  }\n\n  .CodeMirror-sizer {\n    position: relative;\n    border-right: 30px solid transparent;\n  }\n\n  /*\n    The fake, visible scrollbars. Used to force redraw during scrolling before\n    actual scrolling happens, thus preventing shaking and flickering artifacts.\n   */\n  .CodeMirror-vscrollbar,\n  .CodeMirror-hscrollbar,\n  .CodeMirror-scrollbar-filler,\n  .CodeMirror-gutter-filler {\n    display: none;\n    position: absolute;\n    z-index: 6;\n  }\n\n  .CodeMirror-vscrollbar {\n    right: 0;\n    top: 0;\n\n    overflow-x: hidden;\n    overflow-y: scroll;\n  }\n\n  .CodeMirror-hscrollbar {\n    bottom: 0;\n    left: 0;\n\n    overflow-y: hidden;\n    overflow-x: scroll;\n  }\n\n  .CodeMirror-scrollbar-filler {\n    right: 0;\n    bottom: 0;\n  }\n\n  .CodeMirror-gutter-filler {\n    left: 0;\n    bottom: 0;\n  }\n\n  .CodeMirror-gutters {\n    position: absolute;\n    left: 0;\n    top: 0;\n\n    min-height: 100%;\n    z-index: 3;\n  }\n\n  .CodeMirror-gutter {\n    display: inline-block;\n    vertical-align: top;\n\n    margin-bottom: -30px;\n\n    white-space: normal;\n    height: 100%;\n  }\n\n  .CodeMirror-gutter-wrapper {\n    position: absolute;\n\n    background: none !important;\n    border: none !important;\n\n    z-index: 4;\n  }\n\n  .CodeMirror-gutter-background {\n    position: absolute;\n    top: 0;\n    bottom: 0;\n\n    z-index: 4;\n  }\n\n  .CodeMirror-gutter-elt {\n    position: absolute;\n    cursor: default;\n    z-index: 4;\n  }\n\n  .CodeMirror-gutter-wrapper ::selection {\n    background-color: transparent;\n  }\n\n  .CodeMirror-gutter-wrapper ::-moz-selection {\n    background-color: transparent;\n  }\n\n  .CodeMirror-lines {\n    cursor: text;\n\n    /* Prevents collapsing before first draw */\n    min-height: 1px;\n  }\n\n  /* Scroll addon */\n  .CodeMirror-overlayscroll .CodeMirror-scrollbar-filler,\n  .CodeMirror-overlayscroll .CodeMirror-gutter-filler {\n    display: none;\n  }\n\n  .CodeMirror-simplescroll-horizontal,\n  .CodeMirror-simplescroll-vertical,\n  .CodeMirror-overlayscroll-horizontal,\n  .CodeMirror-overlayscroll-vertical {\n    position: absolute;\n    z-index: 6;\n\n    div {\n      position: absolute;\n      box-sizing: border-box;\n\n      background: ", ";\n      border-width: 1px;\n      border-style: solid;\n      border-color: ", ";\n      border-radius: 3px;\n    }\n  }\n\n  .CodeMirror-simplescroll-horizontal,\n  .CodeMirror-overlayscroll-horizontal {\n    bottom: 0;\n    left: 0;\n    height: 6px;\n\n    div {\n      bottom: 0;\n      height: 100%;\n    }\n  }\n\n  .CodeMirror-simplescroll-vertical,\n  .CodeMirror-overlayscroll-vertical {\n    right: 0;\n    top: 0;\n    width: 6px;\n\n    div {\n      right: 0;\n      width: 100%;\n    }\n  }\n\n  /* Reset some styles that the rest of the page might have set */\n  .CodeMirror pre {\n    position: relative;\n    overflow: visible;\n\n    margin: 0;\n\n    border-radius: 0;\n    border-width: 0;\n\n    background: transparent;\n\n    font-feature-settings: \"calt\" 1;\n    font-variant-ligatures: contextual;\n    font-family: inherit;\n    font-size: inherit;\n    color: inherit;\n\n    line-height: inherit;\n    white-space: pre;\n    word-wrap: normal;\n\n    z-index: 2;\n  }\n\n  .CodeMirror-wrap pre {\n    word-wrap: break-word;\n    white-space: pre-wrap;\n    word-break: normal;\n  }\n\n  .CodeMirror-linebackground {\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    z-index: 0;\n  }\n\n  .CodeMirror-linewidget {\n    position: relative;\n    z-index: 2;\n    padding: 0.1px; /* Force widget margins to stay inside of the container */\n  }\n\n  .CodeMirror-widget {\n  }\n\n  .CodeMirror-rtl pre {\n    direction: rtl;\n  }\n\n  .CodeMirror-code {\n    outline: none;\n  }\n\n  /* Force content-box sizing for the elements where we expect it */\n  .CodeMirror-scroll,\n  .CodeMirror-sizer,\n  .CodeMirror-gutter,\n  .CodeMirror-gutters,\n  .CodeMirror-linenumber {\n    box-sizing: content-box;\n  }\n\n  .CodeMirror-measure {\n    position: absolute;\n    width: 100%;\n    height: 0;\n    overflow: hidden;\n    visibility: hidden;\n  }\n\n  .CodeMirror-cursor {\n    position: absolute;\n    pointer-events: none;\n  }\n  .CodeMirror-measure pre {\n    position: static;\n  }\n\n  div.CodeMirror-cursors {\n    visibility: hidden;\n    position: relative;\n    z-index: 3;\n  }\n  div.CodeMirror-dragcursors {\n    visibility: visible;\n  }\n\n  .CodeMirror-focused div.CodeMirror-cursors {\n    visibility: visible;\n  }\n\n  /* Used to force a border model for a node */\n  .cm-force-border {\n    padding-right: 0.1px;\n  }\n\n  /* See issue #2901 */\n  .cm-tab-wrap-hack:after {\n    content: \"\";\n  }\n\n  /* Help users use markselection to safely style text background */\n  span.CodeMirror-selectedtext {\n    background: none;\n  }\n"], ["\n  &.react-codemirror2 {\n    height: 100%;\n  }\n\n  .CodeMirror {\n    height: 100%;\n    width: 100%;\n\n    font-feature-settings: \"calt\" 1;\n    font-variant-ligatures: contextual;\n    font-family: \"Fira Code\", Monaco, monospace;\n    font-weight: 400;\n\n    background: ", ";\n    color: ", ";\n\n    direction: ltr;\n  }\n\n  /* Vertical padding around content */\n  .CodeMirror-lines {\n    padding: 0.5rem 0;\n  }\n\n  /* Horizontal padding of content */\n  .CodeMirror pre {\n    padding: 0 0.5rem;\n  }\n\n  /* The little square between H and V scrollbars? */\n  .CodeMirror-scrollbar-filler,\n  .CodeMirror-gutter-filler {\n    background-color: red;\n  }\n\n  /* Gutters */\n  .CodeMirror-gutters {\n    border-right-width: 1px;\n    border-right-style: solid;\n    border-right-color: ", ";\n\n    background-color: ", ";\n    white-space: nowrap;\n  }\n\n  .CodeMirror-linenumbers {\n  }\n\n  .CodeMirror-linenumber {\n    padding: 0 0.25rem 0 0.25rem;\n    margin: 0;\n\n    min-width: 1.5rem;\n    text-align: right;\n\n    color: ", ";\n    white-space: nowrap;\n  }\n\n  .CodeMirror-guttermarker {\n    color: ", ";\n  }\n\n  .CodeMirror-guttermarker-subtle {\n    color: ", ";\n  }\n\n  /* Cursor */\n  .CodeMirror-cursor {\n    border-left-width: 2px;\n    border-left-style: solid;\n    border-left-color: ", ";\n\n    width: 0;\n  }\n\n  /* Shown when moving in bi-directional text */\n  .CodeMirror div.CodeMirror-secondarycursor {\n    border-left-width: 2px;\n    border-left-style: solid;\n    border-left-color: ", ";\n  }\n\n  /* Can style cursor different in overwrite (non-insert) mode */\n  .CodeMirror-overwrite .CodeMirror-cursor {\n  }\n\n  .CodeMirror-ruler {\n    position: absolute;\n    top: 0;\n    bottom: 0;\n\n    border-left-width: 2px;\n    border-left-style: solid;\n    border-left-color: ", ";\n  }\n\n  .CodeMirror-selected {\n    background-color: ", ";\n  }\n\n  .CodeMirror-focused .CodeMirror-selected {\n    background-color: ", ";\n    color: ", ";\n  }\n\n  .CodeMirror-line::selection,\n  .CodeMirror-line > span::selection,\n  .CodeMirror-line > span > span::selection {\n    background-color: ", ";\n    color: ", ";\n  }\n\n  .CodeMirror-crosshair {\n    cursor: crosshair;\n  }\n\n  .CodeMirror-activeline-background {\n    background-color: ", ";\n  }\n\n  .cm-searching {\n    background-color: ", ";\n  }\n\n  .cm-header,\n  .cm-strong {\n    font-weight: bold;\n  }\n\n  .cm-em {\n    font-style: italic;\n  }\n\n  .cm-link {\n    text-decoration: underline;\n  }\n\n  .cm-strikethrough {\n    text-decoration: line-through;\n  }\n\n  .cm-s-default {\n    .cm-keyword {\n      color: ", ";\n    }\n\n    .cm-meta,\n    .cm-bracket,\n    .cm-operator,\n    .cm-qualifier,\n    .cm-punctuation {\n      color: ", ";\n    }\n\n    .cm-comment {\n      color: ", ";\n    }\n\n    .cm-variable,\n    .cm-variable-2,\n    .cm-variable-3 {\n      color: ", ";\n    }\n\n    .cm-property {\n      color: ", ";\n    }\n\n    .cm-tag {\n      color: ", ";\n    }\n\n    .cm-number,\n    .cm-string,\n    .cm-string-2 {\n      color: ", ";\n    }\n\n    .cm-attribute {\n      color: ", ";\n    }\n\n    .cm-atom {\n      color: ", ";\n    }\n\n    .cm-def {\n      color: ", ";\n    }\n\n    .cm-type {\n      color: ", ";\n    }\n\n    .cm-builtin {\n      color: ", ";\n    }\n\n    .cm-hr {\n      color: ", ";\n    }\n\n    .cm-link {\n      color: ", ";\n    }\n\n    .cm-error {\n      color: #d44;\n    }\n\n    .cm-quote {\n      color: ", ";\n    }\n\n    .cm-header {\n      color: blue;\n    }\n  }\n\n  .cm-negative {\n    color: #d44;\n  }\n  .cm-positive {\n    color: #292;\n  }\n\n  .cm-invalidchar {\n    color: #d44;\n  }\n\n  /* Default styles for common addons */\n\n  div.CodeMirror span.CodeMirror-matchingbracket {\n    color: #0b0;\n  }\n\n  div.CodeMirror span.CodeMirror-nonmatchingbracket {\n    color: #a22;\n  }\n\n  .CodeMirror-matchingtag {\n    background: rgba(255, 150, 0, 0.3);\n  }\n\n  .CodeMirror-composing {\n    border-bottom-width: 2px;\n    border-bottom-style: solid;\n  }\n\n  .cm-tab {\n    display: inline-block;\n    text-decoration: inherit;\n  }\n\n  .CodeMirror-rulers {\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: -50px;\n    bottom: -20px;\n\n    overflow-x: hidden;\n    overflow-y: hidden;\n  }\n\n  /**\n   * The rest of this file contains styles related to the mechanics of the\n   * editor. You probably shouldn't touch them.\n   */\n\n  .CodeMirror {\n    position: relative;\n    overflow: hidden;\n  }\n\n  .CodeMirror-scroll {\n    position: relative;\n\n    /* 30px is the magic margin used to hide the element's real scrollbars */\n    /* See overflow: hidden in .CodeMirror */\n    margin-bottom: -30px;\n    margin-right: -30px;\n    padding-bottom: 30px;\n\n    height: 100%;\n    outline: none;\n\n    /* Things will break if this is overridden */\n    overflow: scroll !important;\n  }\n\n  .CodeMirror-sizer {\n    position: relative;\n    border-right: 30px solid transparent;\n  }\n\n  /*\n    The fake, visible scrollbars. Used to force redraw during scrolling before\n    actual scrolling happens, thus preventing shaking and flickering artifacts.\n   */\n  .CodeMirror-vscrollbar,\n  .CodeMirror-hscrollbar,\n  .CodeMirror-scrollbar-filler,\n  .CodeMirror-gutter-filler {\n    display: none;\n    position: absolute;\n    z-index: 6;\n  }\n\n  .CodeMirror-vscrollbar {\n    right: 0;\n    top: 0;\n\n    overflow-x: hidden;\n    overflow-y: scroll;\n  }\n\n  .CodeMirror-hscrollbar {\n    bottom: 0;\n    left: 0;\n\n    overflow-y: hidden;\n    overflow-x: scroll;\n  }\n\n  .CodeMirror-scrollbar-filler {\n    right: 0;\n    bottom: 0;\n  }\n\n  .CodeMirror-gutter-filler {\n    left: 0;\n    bottom: 0;\n  }\n\n  .CodeMirror-gutters {\n    position: absolute;\n    left: 0;\n    top: 0;\n\n    min-height: 100%;\n    z-index: 3;\n  }\n\n  .CodeMirror-gutter {\n    display: inline-block;\n    vertical-align: top;\n\n    margin-bottom: -30px;\n\n    white-space: normal;\n    height: 100%;\n  }\n\n  .CodeMirror-gutter-wrapper {\n    position: absolute;\n\n    background: none !important;\n    border: none !important;\n\n    z-index: 4;\n  }\n\n  .CodeMirror-gutter-background {\n    position: absolute;\n    top: 0;\n    bottom: 0;\n\n    z-index: 4;\n  }\n\n  .CodeMirror-gutter-elt {\n    position: absolute;\n    cursor: default;\n    z-index: 4;\n  }\n\n  .CodeMirror-gutter-wrapper ::selection {\n    background-color: transparent;\n  }\n\n  .CodeMirror-gutter-wrapper ::-moz-selection {\n    background-color: transparent;\n  }\n\n  .CodeMirror-lines {\n    cursor: text;\n\n    /* Prevents collapsing before first draw */\n    min-height: 1px;\n  }\n\n  /* Scroll addon */\n  .CodeMirror-overlayscroll .CodeMirror-scrollbar-filler,\n  .CodeMirror-overlayscroll .CodeMirror-gutter-filler {\n    display: none;\n  }\n\n  .CodeMirror-simplescroll-horizontal,\n  .CodeMirror-simplescroll-vertical,\n  .CodeMirror-overlayscroll-horizontal,\n  .CodeMirror-overlayscroll-vertical {\n    position: absolute;\n    z-index: 6;\n\n    div {\n      position: absolute;\n      box-sizing: border-box;\n\n      background: ", ";\n      border-width: 1px;\n      border-style: solid;\n      border-color: ", ";\n      border-radius: 3px;\n    }\n  }\n\n  .CodeMirror-simplescroll-horizontal,\n  .CodeMirror-overlayscroll-horizontal {\n    bottom: 0;\n    left: 0;\n    height: 6px;\n\n    div {\n      bottom: 0;\n      height: 100%;\n    }\n  }\n\n  .CodeMirror-simplescroll-vertical,\n  .CodeMirror-overlayscroll-vertical {\n    right: 0;\n    top: 0;\n    width: 6px;\n\n    div {\n      right: 0;\n      width: 100%;\n    }\n  }\n\n  /* Reset some styles that the rest of the page might have set */\n  .CodeMirror pre {\n    position: relative;\n    overflow: visible;\n\n    margin: 0;\n\n    border-radius: 0;\n    border-width: 0;\n\n    background: transparent;\n\n    font-feature-settings: \"calt\" 1;\n    font-variant-ligatures: contextual;\n    font-family: inherit;\n    font-size: inherit;\n    color: inherit;\n\n    line-height: inherit;\n    white-space: pre;\n    word-wrap: normal;\n\n    z-index: 2;\n  }\n\n  .CodeMirror-wrap pre {\n    word-wrap: break-word;\n    white-space: pre-wrap;\n    word-break: normal;\n  }\n\n  .CodeMirror-linebackground {\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    z-index: 0;\n  }\n\n  .CodeMirror-linewidget {\n    position: relative;\n    z-index: 2;\n    padding: 0.1px; /* Force widget margins to stay inside of the container */\n  }\n\n  .CodeMirror-widget {\n  }\n\n  .CodeMirror-rtl pre {\n    direction: rtl;\n  }\n\n  .CodeMirror-code {\n    outline: none;\n  }\n\n  /* Force content-box sizing for the elements where we expect it */\n  .CodeMirror-scroll,\n  .CodeMirror-sizer,\n  .CodeMirror-gutter,\n  .CodeMirror-gutters,\n  .CodeMirror-linenumber {\n    box-sizing: content-box;\n  }\n\n  .CodeMirror-measure {\n    position: absolute;\n    width: 100%;\n    height: 0;\n    overflow: hidden;\n    visibility: hidden;\n  }\n\n  .CodeMirror-cursor {\n    position: absolute;\n    pointer-events: none;\n  }\n  .CodeMirror-measure pre {\n    position: static;\n  }\n\n  div.CodeMirror-cursors {\n    visibility: hidden;\n    position: relative;\n    z-index: 3;\n  }\n  div.CodeMirror-dragcursors {\n    visibility: visible;\n  }\n\n  .CodeMirror-focused div.CodeMirror-cursors {\n    visibility: visible;\n  }\n\n  /* Used to force a border model for a node */\n  .cm-force-border {\n    padding-right: 0.1px;\n  }\n\n  /* See issue #2901 */\n  .cm-tab-wrap-hack:after {\n    content: \"\";\n  }\n\n  /* Help users use markselection to safely style text background */\n  span.CodeMirror-selectedtext {\n    background: none;\n  }\n"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactCodemirror = require("react-codemirror2");

require("codemirror/mode/gfm/gfm");

require("codemirror/mode/xml/xml");

require("codemirror/mode/javascript/javascript");

require("codemirror/addon/edit/closebrackets");

require("codemirror/addon/scroll/scrollpastend");

require("codemirror/addon/scroll/simplescrollbars");

require("codemirror/addon/selection/active-line");

require("codemirror/keymap/sublime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var defaultOptions = {
  mode: "gfm",
  autofocus: true,
  lineNumbers: false,
  lineWrapping: true,
  styleActiveLine: true,
  scrollbarStyle: "overlay",
  scrollPastEnd: false,
  indentUnit: 4,
  autoCloseBrackets: true,
  keyMap: "sublime"
};

var RawEditor = function RawEditor(props) {
  var options = Object.assign(defaultOptions, props.options);

  return _react2.default.createElement(_reactCodemirror.Controlled, _extends({}, props, { options: options }));
};

/* stylelint-disable */
var Editor = (0, _styledComponents2.default)(RawEditor)(_templateObject, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.foreground;
}, function (props) {
  return props.theme.border;
}, function (props) {
  return props.theme.gutter;
}, function (props) {
  return props.theme.gutterForeground;
}, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.caret;
}, function (props) {
  return props.theme.caret;
}, function (props) {
  return props.theme.border;
}, function (props) {
  return props.theme.selection;
}, function (props) {
  return props.theme.selection;
}, function (props) {
  return props.theme.selectionForeground;
}, function (props) {
  return props.theme.inactiveSelection;
}, function (props) {
  return props.theme.inactiveSelectionForeground;
}, function (props) {
  return props.theme.lineHighlight;
}, function (props) {
  return props.theme.findHighlight;
}, function (props) {
  return props.theme.syntax.keyword;
}, function (props) {
  return props.theme.syntax.comment;
}, function (props) {
  return props.theme.syntax.comment;
}, function (props) {
  return props.theme.syntax.variable;
}, function (props) {
  return props.theme.syntax.property;
}, function (props) {
  return props.theme.syntax.tag;
}, function (props) {
  return props.theme.syntax.value;
}, function (props) {
  return props.theme.syntax.attribute;
}, function (props) {
  return props.theme.syntax.snipped;
}, function (props) {
  return props.theme.syntax.class;
}, function (props) {
  return props.theme.syntax.keyword;
}, function (props) {
  return props.theme.syntax.keyword;
}, function (props) {
  return props.theme.syntax.comment;
}, function (props) {
  return props.theme.syntax.import;
}, function (props) {
  return props.theme.syntax.comment;
}, function (props) {
  return props.theme.gutter;
}, function (props) {
  return props.theme.gutterForeground;
});
/* stylelint-enable */

exports.default = Editor;
exports.RawEditor = RawEditor;