"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  outline: none;\n  cursor: pointer;\n\n  border-width: 1px;\n  border-style: solid;\n  border-radius: 3px;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  font-size: 0.85rem;\n  font-weight: 500;\n\n  padding: 0.25rem 0.75rem;\n  margin: 0.5rem;\n\n  ", ";\n\n  ", ";\n\n  ", ";\n\n  appearance: none;\n  -webkit-app-region: no-drag;\n"], ["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  outline: none;\n  cursor: pointer;\n\n  border-width: 1px;\n  border-style: solid;\n  border-radius: 3px;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  font-size: 0.85rem;\n  font-weight: 500;\n\n  padding: 0.25rem 0.75rem;\n  margin: 0.5rem;\n\n  ", ";\n\n  ", ";\n\n  ", ";\n\n  appearance: none;\n  -webkit-app-region: no-drag;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n    font-size: 1rem;\n    padding: .25rem 1rem;\n  "], ["\n    font-size: 1rem;\n    padding: .25rem 1rem;\n  "]),
    _templateObject3 = _taggedTemplateLiteral(["\n    font-size: .65rem;\n    padding: 0.25rem .65rem;\n  "], ["\n    font-size: .65rem;\n    padding: 0.25rem .65rem;\n  "]),
    _templateObject4 = _taggedTemplateLiteral(["\n    display: inline-flex;\n  "], ["\n    display: inline-flex;\n  "]);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _styledIs = require("styled-is");

var _styledIs2 = _interopRequireDefault(_styledIs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Button = _styledComponents2.default.button(_templateObject, function (props) {
  return props.theme.border;
}, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.foreground;
}, (0, _styledIs2.default)("large")(_templateObject2), (0, _styledIs2.default)("small")(_templateObject3), (0, _styledIs2.default)("inline")(_templateObject4));

exports.default = Button;