"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListSeparator = exports.ListText = exports.ListItem = undefined;

var _templateObject = _taggedTemplateLiteral(["\n  position: relative;\n\n  margin: 0;\n  padding: 0;\n\n  list-style: none;\n"], ["\n  position: relative;\n\n  margin: 0;\n  padding: 0;\n\n  list-style: none;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n  position: relative;\n  display: flex;\n\n  align-items: center;\n  vertical-align: middle;\n  justify-content: flex-start;\n\n  text-align: left;\n  text-decoration: none;\n  color: ", ";\n\n  padding: 0.75rem 1rem;\n  margin: 0;\n\n  width: 100%;\n  min-height: 55px;\n\n  transition: background-color 150ms ease;\n\n  &[href]:hover {\n    background-color: ", ";\n  }\n"], ["\n  position: relative;\n  display: flex;\n\n  align-items: center;\n  vertical-align: middle;\n  justify-content: flex-start;\n\n  text-align: left;\n  text-decoration: none;\n  color: ", ";\n\n  padding: 0.75rem 1rem;\n  margin: 0;\n\n  width: 100%;\n  min-height: 55px;\n\n  transition: background-color 150ms ease;\n\n  &[href]:hover {\n    background-color: ", ";\n  }\n"]),
    _templateObject3 = _taggedTemplateLiteral(["\n  border-width: 0;\n\n  height: 1px;\n  width: 100%;\n\n  background-color: ", ";\n"], ["\n  border-width: 0;\n\n  height: 1px;\n  width: 100%;\n\n  background-color: ", ";\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  flex: 1 1 auto;\n\n  padding: 0 1rem;\n"], ["\n  flex: 1 1 auto;\n\n  padding: 0 1rem;\n"]),
    _templateObject5 = _taggedTemplateLiteral(["\n  margin: 0;\n  padding: 0;\n"], ["\n  margin: 0;\n  padding: 0;\n"]),
    _templateObject6 = _taggedTemplateLiteral(["\n  opacity: 0.75;\n  font-size: 0.85rem;\n"], ["\n  opacity: 0.75;\n  font-size: 0.85rem;\n"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var List = _styledComponents2.default.nav(_templateObject);

var ListItem = (0, _styledComponents2.default)(function (_ref) {
  var _ref$component = _ref.component,
      component = _ref$component === undefined ? _react2.default.createElement("li", null) : _ref$component,
      props = _objectWithoutProperties(_ref, ["component"]);

  return _react2.default.cloneElement(component, props);
})(_templateObject2, function (props) {
  return props.theme.foreground;
}, function (props) {
  return props.theme.border;
});

var ListSeparator = _styledComponents2.default.hr(_templateObject3, function (props) {
  return props.theme.border;
});

var ListTextContainer = _styledComponents2.default.div(_templateObject4);

var ListPrimary = _styledComponents2.default.p(_templateObject5);

var ListSecondary = ListPrimary.extend(_templateObject6);

function ListText(props) {
  return _react2.default.createElement(
    ListTextContainer,
    null,
    props.primary ? _react2.default.createElement(
      ListPrimary,
      null,
      props.primary
    ) : null,
    props.secondary ? _react2.default.createElement(
      ListSecondary,
      null,
      props.secondary
    ) : null
  );
}

ListText.propTypes = {
  primary: _propTypes2.default.node,
  secondary: _propTypes2.default.node
};

exports.default = List;
exports.ListItem = ListItem;
exports.ListText = ListText;
exports.ListSeparator = ListSeparator;