"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(["\n  display: grid;\n  grid-template-areas: \"a b c\";\n  grid-template-columns: 1fr auto 1fr;\n\n  margin: 0;\n  padding: 0 0.5rem;\n\n  min-height: 2rem;\n  width: 100%;\n\n  border-width: 0;\n  border-style: solid;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  ", ";\n\n  ", ";\n\n  -webkit-app-region: drag;\n\n  & > * {\n    display: flex;\n\n    align-items: center;\n    justify-self: center;\n\n    &:last-child {\n      justify-self: end;\n      grid-column-end: c;\n    }\n\n    &:first-child {\n      justify-self: start;\n      grid-column-end: a;\n    }\n  }\n"], ["\n  display: grid;\n  grid-template-areas: \"a b c\";\n  grid-template-columns: 1fr auto 1fr;\n\n  margin: 0;\n  padding: 0 0.5rem;\n\n  min-height: 2rem;\n  width: 100%;\n\n  border-width: 0;\n  border-style: solid;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  ", ";\n\n  ", ";\n\n  -webkit-app-region: drag;\n\n  & > * {\n    display: flex;\n\n    align-items: center;\n    justify-self: center;\n\n    &:last-child {\n      justify-self: end;\n      grid-column-end: c;\n    }\n\n    &:first-child {\n      justify-self: start;\n      grid-column-end: a;\n    }\n  }\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n    border-bottom-width: 1px;\n  "], ["\n    border-bottom-width: 1px;\n  "]),
    _templateObject3 = _taggedTemplateLiteral(["\n    border-top-width: 1px;\n  "], ["\n    border-top-width: 1px;\n  "]);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _styledIs = require("styled-is");

var _styledIs2 = _interopRequireDefault(_styledIs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Bar = _styledComponents2.default.header(_templateObject, function (props) {
  return props.theme.border;
}, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.foreground;
}, (0, _styledIs2.default)("header")(_templateObject2), (0, _styledIs2.default)("footer")(_templateObject3));

exports.default = Bar;