"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(["\n  position: relative;\n  display: inline-flex;\n  vertical-align: middle;\n\n  width: 17px;\n  height: 17px;\n\n  outline: none;\n  cursor: pointer;\n\n  border-width: 1px;\n  border-style: solid;\n  border-radius: 3px;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  padding: 0;\n  margin: 6px 20px 6px 12px;\n\n  transition: background-color 0.16s cubic-bezier(0.5, 0.15, 0.2, 1),\n    border-color 0.16s cubic-bezier(0.5, 0.15, 0.2, 1);\n\n  &:checked {\n    border-color: ", ";\n    background-color: ", ";\n  }\n\n  &::before,\n  &::after {\n    position: absolute;\n    top: 12px;\n    left: 6px;\n\n    height: 2px;\n\n    border-width: 0;\n    border-radius: 1px;\n    background-color: ", ";\n\n    transform-origin: 0 0;\n    transition: transform 0.1s cubic-bezier(0.5, 0.15, 0.2, 1),\n      opacity 0.1s cubic-bezier(0.5, 0.15, 0.2, 1);\n\n    content: \"\";\n    opacity: 0;\n  }\n\n  &::before {\n    transform: translate3d(0, 0, 0) rotate(225deg) scale(0);\n    width: 6px;\n  }\n\n  &:checked::before {\n    transform: translate3d(0, 0, 0) rotate(225deg) scale(1);\n    opacity: 1;\n  }\n\n  &::after {\n    transform: translate3d(0, 0, 0) rotate(-45deg) scale(0);\n    width: 11px;\n    margin: -1px;\n  }\n\n  &:checked::after {\n    transform: translate3d(0, 0, 0) rotate(-45deg) scale(1);\n    opacity: 1;\n  }\n\n  -webkit-app-region: no-drag;\n  appearance: none;\n"], ["\n  position: relative;\n  display: inline-flex;\n  vertical-align: middle;\n\n  width: 17px;\n  height: 17px;\n\n  outline: none;\n  cursor: pointer;\n\n  border-width: 1px;\n  border-style: solid;\n  border-radius: 3px;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  padding: 0;\n  margin: 6px 20px 6px 12px;\n\n  transition: background-color 0.16s cubic-bezier(0.5, 0.15, 0.2, 1),\n    border-color 0.16s cubic-bezier(0.5, 0.15, 0.2, 1);\n\n  &:checked {\n    border-color: ", ";\n    background-color: ", ";\n  }\n\n  &::before,\n  &::after {\n    position: absolute;\n    top: 12px;\n    left: 6px;\n\n    height: 2px;\n\n    border-width: 0;\n    border-radius: 1px;\n    background-color: ", ";\n\n    transform-origin: 0 0;\n    transition: transform 0.1s cubic-bezier(0.5, 0.15, 0.2, 1),\n      opacity 0.1s cubic-bezier(0.5, 0.15, 0.2, 1);\n\n    content: \"\";\n    opacity: 0;\n  }\n\n  &::before {\n    transform: translate3d(0, 0, 0) rotate(225deg) scale(0);\n    width: 6px;\n  }\n\n  &:checked::before {\n    transform: translate3d(0, 0, 0) rotate(225deg) scale(1);\n    opacity: 1;\n  }\n\n  &::after {\n    transform: translate3d(0, 0, 0) rotate(-45deg) scale(0);\n    width: 11px;\n    margin: -1px;\n  }\n\n  &:checked::after {\n    transform: translate3d(0, 0, 0) rotate(-45deg) scale(1);\n    opacity: 1;\n  }\n\n  -webkit-app-region: no-drag;\n  appearance: none;\n"]);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Checkbox = _styledComponents2.default.input.attrs({
  type: "checkbox"
})(_templateObject, function (props) {
  return props.theme.border;
}, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.foreground;
}, function (props) {
  return props.theme.caret;
}, function (props) {
  return props.theme.caret;
}, function (props) {
  return props.theme.background;
});

exports.default = Checkbox;