"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(["\n  &::placeholder {\n    opacity: 0.75;\n  }\n\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  width: 90%;\n\n  outline: none;\n  cursor: pointer;\n\n  border-width: 1px;\n  border-style: solid;\n  border-radius: 3px;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  line-height: 1.5;\n  font-size: 0.85rem;\n  font-weight: 400;\n\n  padding: 0.5rem;\n  margin: 0.5rem 0;\n\n  &:focus {\n    border-color: ", ";\n    box-shadow: 0 0 0 1px ", ";\n  }\n\n  ", ";\n\n  ", ";\n\n  ", ";\n\n  -webkit-app-region: no-drag;\n  appearance: textfield;\n"], ["\n  &::placeholder {\n    opacity: 0.75;\n  }\n\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  width: 90%;\n\n  outline: none;\n  cursor: pointer;\n\n  border-width: 1px;\n  border-style: solid;\n  border-radius: 3px;\n  border-color: ", ";\n\n  background-color: ", ";\n  color: ", ";\n\n  line-height: 1.5;\n  font-size: 0.85rem;\n  font-weight: 400;\n\n  padding: 0.5rem;\n  margin: 0.5rem 0;\n\n  &:focus {\n    border-color: ", ";\n    box-shadow: 0 0 0 1px ", ";\n  }\n\n  ", ";\n\n  ", ";\n\n  ", ";\n\n  -webkit-app-region: no-drag;\n  appearance: textfield;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n    font-size: 1rem;\n    padding: 0.85rem;\n  "], ["\n    font-size: 1rem;\n    padding: 0.85rem;\n  "]),
    _templateObject3 = _taggedTemplateLiteral(["\n    font-size: .65rem;\n    padding: 0.35rem;\n  "], ["\n    font-size: .65rem;\n    padding: 0.35rem;\n  "]),
    _templateObject4 = _taggedTemplateLiteral(["\n    display: inline-flex;\n    width: auto;\n  "], ["\n    display: inline-flex;\n    width: auto;\n  "]);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _styledIs = require("styled-is");

var _styledIs2 = _interopRequireDefault(_styledIs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Input = _styledComponents2.default.input(_templateObject, function (props) {
  return props.theme.border;
}, function (props) {
  return props.theme.background;
}, function (props) {
  return props.theme.foreground;
}, function (props) {
  return props.theme.caret;
}, function (props) {
  return props.theme.caret;
}, (0, _styledIs2.default)("large")(_templateObject2), (0, _styledIs2.default)("small")(_templateObject3), (0, _styledIs2.default)("inline")(_templateObject4));

exports.default = Input;