"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LabelSub = exports.LabelSup = exports.LabelDescription = undefined;

var _templateObject = _taggedTemplateLiteral(["\n  display: flex;\n  flex-wrap: wrap;\n  flex-direction: row;\n\n  cursor: pointer;\n  user-select: none;\n\n  margin: 0.5rem;\n"], ["\n  display: flex;\n  flex-wrap: wrap;\n  flex-direction: row;\n\n  cursor: pointer;\n  user-select: none;\n\n  margin: 0.5rem;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n  display: flex;\n  flex-direction: column;\n  flex: 0 0 calc(100% - 50px);\n\n  justify-content: center;\n"], ["\n  display: flex;\n  flex-direction: column;\n  flex: 0 0 calc(100% - 50px);\n\n  justify-content: center;\n"]),
    _templateObject3 = _taggedTemplateLiteral(["\n  font-weight: 500;\n  font-size: 1rem;\n\n  margin: 5px 0;\n"], ["\n  font-weight: 500;\n  font-size: 1rem;\n\n  margin: 5px 0;\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  font-weight: normal;\n  font-size: 0.85rem;\n\n  margin: 0 0 2px;\n  opacity: 0.85;\n"], ["\n  font-weight: normal;\n  font-size: 0.85rem;\n\n  margin: 0 0 2px;\n  opacity: 0.85;\n"]);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Label = _styledComponents2.default.label(_templateObject);

var LabelDescription = _styledComponents2.default.div(_templateObject2);

var LabelSup = _styledComponents2.default.div(_templateObject3);

var LabelSub = _styledComponents2.default.div(_templateObject4);

exports.default = Label;
exports.LabelDescription = LabelDescription;
exports.LabelSup = LabelSup;
exports.LabelSub = LabelSub;